#define DOCTEST_CONFIG_NO_MULTITHREADING
#define DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN
#include "doctest.h"
#include "histogram_internal.h"
#include "range_border.h"

TEST_CASE("distinct positive numbers") {
    double min = 0;
    double max = 0;
    find_minmax({ 1, 2 }, min, max);
    CHECK(min == 1);
    CHECK(max == 2);
}

TEST_CASE("empty vector") {
    double min = 0;
    double max = 0;
    CHECK(!find_minmax({}, min, max));
}

TEST_CASE("negative values") {
    double min = 0;
    double max = 0;
    find_minmax({-2, -4}, min, max);
    CHECK(min == -4);
    CHECK(max == -2);
}

TEST_CASE("negative borders") {
    double range_border = 0;
    find_range_border({-2, -4}, 2, 1, range_border);
    CHECK(range_border == -3);
}

TEST_CASE("more bins than numbers") {
    double range_border = 0;
    find_range_border({3}, 2, 1, range_border);
    CHECK(range_border == 3);
}